﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections.ObjectModel;
using System.Text.RegularExpressions;

namespace ServiceTrackerLogic
{
	public class Accounts : ObservableCollection<Account>
	{
		public event EventHandler Updated;

		private static Accounts accountStore;
		public static Accounts AccountStore
		{
			get
			{
				if (accountStore == null)
				{
					accountStore = new Accounts();
					accountStore.Add(Account.CreateAccount("Test User", "813-555-1234"));
					accountStore.Add(Account.CreateAccount("Justin Example", "813-555-1212"));
				}
				return accountStore;
			}
			set { accountStore = value; }
		}

		public Accounts(List<Account> accounts) : base(accounts) { }
		public Accounts() : base() { }

		String currentSearchCriteria = String.Empty;

		public Accounts FindAccount(string searchCriteria)
		{
			List<Account> a = new List<Account>(this);
			currentSearchCriteria = searchCriteria;
			Accounts foundAccounts =
				new Accounts(a.FindAll(MatchesNameOrPhone));
			currentSearchCriteria = String.Empty;
			return foundAccounts;
		}

        private bool MatchesNameOrPhone(Account account)
        {
            PhoneNumber pn = new PhoneNumber(account.PhoneNumber);

            return account.AccountName.Contains(currentSearchCriteria)
                || pn.ToString().Contains(currentSearchCriteria)
                || pn.AlternateFormat.Contains(currentSearchCriteria);
        }
	}
}
