﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;

namespace ServiceTrackerLogic
{
    public class PhoneNumber
    {
        string phoneNumber = "";

        public PhoneNumber(string phoneNumber)
        {
            //(813) 555-1212
            Regex allowedRegex1 = new Regex(@"\([0-9]{3}\) [0-9]{3}-[0-9]{4}");
            //813-555-1212
            Regex allowedRegex2 = new Regex(@"[0-9]{3}-[0-9]{3}-[0-9]{4}");
            if (phoneNumber == null || phoneNumber.Trim().Length == 0
                || (!allowedRegex1.IsMatch(phoneNumber) && !allowedRegex2.IsMatch(phoneNumber)))
            {
                throw new ArgumentException("Phone Number is required");
            }

            if (allowedRegex2.IsMatch(phoneNumber))
            {
                string p1 = phoneNumber.Substring(0, 3);
                string p2 = phoneNumber.Substring(4);
                this.phoneNumber = String.Format("({0}) {1}", p1, p2);
            }
            else
            {
                this.phoneNumber = phoneNumber;
            }
        }

        public string AlternateFormat
        {
            get 
            {
                string p1 = phoneNumber.Substring(1, 3);
                string p2 = phoneNumber.Substring(6);
                return String.Format("{0}-{1}", p1, p2); 
            }
        }

        public override string ToString()
        {
            return phoneNumber;
        }
    }
}
